﻿using System;
using System.Collections.Generic;
using System.Runtime.InteropServices;
using System.Net;
using System.Security.Cryptography.X509Certificates;
using System.IO;

namespace PBNet.NonVisual
{
	public class MyPolicy : ICertificatePolicy 
	{
		public bool CheckValidationResult(ServicePoint srvPoint, X509Certificate certificate, WebRequest request, int certificateProblem) 
		{
			// Return True to force the certificate to be accepted.
			return true;
		}
	}

    public class HttpWebRequestOTF
    {
        #region Mandatory code

        /// <summary>
        /// Notify Powerbuilder.
        /// </summary>
        /// <param name="notification">the notification</param>
        public void PowerbuilderNotify(string notification)
        {
        }

        #endregion

        #region Members

        #endregion

        #region Ctor, Dtor, Dispose

        /// <summary>
        /// Constructor
        /// </summary>
        public HttpWebRequestOTF()
        {
			System.Net.ServicePointManager.CertificatePolicy = new MyPolicy();
        }

        /// <summary>
        /// Destructor
        /// </summary> 
        ~HttpWebRequestOTF()
        {
        }

        #endregion

        #region Méthods

        /// <summary>
        /// Déclenchement d'une requête
        /// </summary>
        /// <param name="url"></param>
        /// <param name="parameters"></param>
        /// <param name="useragent"></param>
        /// <param name="domain"></param>
        /// <param name="login"></param>
        /// <param name="password"></param>
        /// <returns></returns>
        public string HTTPRequest(string url, string parameters, string useragent, string domain, string login, string password)
        {
            try
            {
                // Une URL a atteindre avant de faire quoique ce soit ?
                if (url == "") 
                    return "Aucune URL à atteindre";

                // Création de la requete HTTP avec l'URL renseignée
                HttpWebRequest request = (HttpWebRequest)WebRequest.Create(url);
                request.ContentType = "application/x-www-form-urlencoded";

                // Utilisation d'une en tete particulier ?
                if (useragent != "")
                    request.UserAgent = useragent;

                // Utilisation d'une authentification  ?
                if (login != "")
                    request.Proxy.Credentials = new NetworkCredential(login, password, domain);

                // Paramètres en post ?
                if (parameters != "")
                {
                    request.Method = "POST";
                    byte[] bytes = System.Text.Encoding.ASCII.GetBytes(parameters);
                    request.ContentLength = bytes.Length;
                    System.IO.Stream requeststream = request.GetRequestStream();
                    requeststream.Write(bytes, 0, bytes.Length);
                    requeststream.Close();
                }

                // Récupération de la réponse
                HttpWebResponse response = (HttpWebResponse)request.GetResponse();
                Stream stream = response.GetResponseStream();
    
                // Lecture du résultat
                StreamReader reader = new StreamReader(stream/*, System.Text.Encoding.UTF8*/);

                // Retour
                return reader.ReadToEnd().Trim();
            }
            catch (Exception erreur)
            {
                // Retour de l'erreur
                return erreur.Message;
            }

        }

        #endregion

    }
}
