PRINT GetDate()
GO

SELECT  L.request_session_id AS SPID, 
        DB_NAME(L.resource_database_id) AS DatabaseName,
        O.Name AS LockedObjectName, 
        /*P.object_id AS LockedObjectId, */
        L.resource_type AS LockedResource, 
        L.request_mode AS LockType,
        ST.text AS SqlStatementText,  
        ES.login_name AS LoginName,
        ES.host_name AS HostName,
        ES.program_name as ProgramName,
        TST.is_user_transaction as IsUserTransaction,
        AT.name as TransactionName,
        CN.auth_scheme as AuthenticationMethod
FROM    sys.dm_tran_locks L
        /*LEFT JOIN sys.partitions P ON P.hobt_id = L.resource_associated_entity_id*/
        LEFT JOIN sys.objects O ON O.object_id = L.resource_associated_entity_id
        LEFT JOIN sys.dm_exec_sessions ES ON ES.session_id = L.request_session_id
        LEFT JOIN sys.dm_tran_session_transactions TST ON ES.session_id = TST.session_id
        LEFT JOIN sys.dm_tran_active_transactions AT ON TST.transaction_id = AT.transaction_id
        LEFT JOIN sys.dm_exec_connections CN ON CN.session_id = ES.session_id
        CROSS APPLY sys.dm_exec_sql_text(CN.most_recent_sql_handle) AS ST
WHERE   resource_database_id = DB_ID() and (L.resource_type = 'PAGE' or L.request_mode in ('X', 'IX'))
ORDER BY L.request_session_id
GO

PRINT ''
GO
PRINT ''
GO
PRINT ''
GO
