SET NOCOUNT ON

-- Tickets  problme
DECLARE curTicket CURSOR STATIC LOCAL FOR 
	SELECT
		TICKET.ID
	FROM
		TICKET 
	WHERE
		NATURE_OP IN ('VT', 'BL', 'HV') and 
		(
			TICKET.TOTAL - TICKET.MONTANT_REMISE  <> (select ISNULL(SUM(TT.TOTAL_TTC), 0) from ticket_tva TT where TT.ID_TICKET = TICKET.ID) 
		OR
			TICKET.TOTAL - TICKET.MONTANT_REMISE  <> (select ISNULL(SUM(TL.MONTANT_HT + MONTANT_TVA), 0) from ticket_ligne TL where TL.ID_TICKET = TICKET.ID)
		) AND
		CODE > 0 AND
		INFOS_INSTANT_T IS NOT NULL
		
-- Parcours des lignes remontes
DECLARE @id NUMERIC(14);
OPEN curTicket;
FETCH curTicket INTO @id;
WHILE @@FETCH_STATUS = 0
BEGIN

	-- Trace
	PRINT 'Traitement du ticket ID=' + CAST(@id as VARCHAR)
	
	-- On efface les infos de la table TICKET_TVA pour ce ticket
	delete TICKET_TVA where ID_TICKET = @id
	
	-- On flag  MENU_R='N' les lignes de menu sans dtails
	update TICKET_LIGNE set MENU_R = 'N' where ID_TICKET = @id and MENU_R = 'O' and not exists (select * from TICKET_LIGNE TL where TL.ID_TICKET = TICKET_LIGNE.ID_TICKET and TL.ID_LIEN_MENU_R = TICKET_LIGNE.ID)
	
	-- On flag  MENU='N' les lignes de formule sans dtails
	update TICKET_LIGNE set MENU = 'N' where ID_TICKET = @id and MENU = 'O' and not exists (select * from TICKET_LIGNE TL where TL.ID_TICKET = TICKET_LIGNE.ID_TICKET and TL.ID_LIEN_MENU = TICKET_LIGNE.ID)
	
	-- Bug de la suppression de menu par la tlcommande
	UPDATE TICKET_LIGNE SET MENU_R = 'O' where ID_TICKET = @id AND MENU_R = 'N' and STATUT = 'N' AND (SELECT TL.MENU_R FROM TICKET_LIGNE TL WHERE TL.ID = TICKET_LIGNE.ID_LIEN_ARTICLE AND STATUT = 'A') = 'O'
	UPDATE TICKET_LIGNE SET ID_LIEN_MENU_R = (SELECT TL.ID FROM TICKET_LIGNE TL WHERE TL.ID_TICKET = @id AND TL.MENU_R = 'O' AND TL.STATUT = 'N' AND TL.ID_LIEN_ARTICLE = TICKET_LIGNE.ID_LIEN_MENU_R) WHERE ID_TICKET = @id AND ID_LIEN_MENU_R is NOT NULL AND STATUT = 'N' AND (SELECT TL.STATUT FROM TICKET_LIGNE TL WHERE TL.ID = TICKET_LIGNE.ID_LIEN_MENU_R) = 'A'
	UPDATE TICKET_LIGNE SET MONTANT_TVA = 0, MONTANT_HT = 0 where ID_TICKET = @id AND MENU_R = 'O'
	UPDATE TICKET_LIGNE set MENU_R = 'N' where ID_TICKET = @id and MENU_R = 'O' and STATUT = 'N' and not exists (select * from TICKET_LIGNE TL where TL.ID_TICKET = TICKET_LIGNE.ID_TICKET and TL.ID_LIEN_MENU_R = TICKET_LIGNE.ID)
	UPDATE TICKET SET TOTAL = (SELECT ISNULL(SUM(MONTANT_TOTAL + SURCOUT_INGREDIENTS + SURCOUT_MENU_R + SURCOUT_ACC - MONTANT_REMISE), 0) FROM TICKET_LIGNE WHERE ID_TICKET = @id AND ID_LIEN_MENU IS NULL) WHERE ID = @id
   
	-- Bug du MENU_R mal renseign
	UPDATE TICKET_LIGNE SET MONTANT_TVA = 0, MONTANT_HT = 0, MONTANT_TOTAL_PRORATISE = 0, PRIX_VENTE_TTC_PRORATISE = 0 WHERE ID_TICKET = @id AND ID_LIEN_MENU IS NULL AND ID_LIEN_MENU_R IS NULL AND MONTANT_TOTAL = 0.0

	-- Bug d'une mauvais explosion de la proratisation
	update TICKET_LIGNE set MONTANT_TVA = 0, MONTANT_HT = 0, MONTANT_TOTAL_PRORATISE = 0, PRIX_VENTE_TTC_PRORATISE = 0 WHERE ID_TICKET = @id and ID_LIEN_MENU_R is not null and not (STATUT='V' and ROLE='N')

   	-- Ligne de menu dont le prorata est faux
	DECLARE curLigne CURSOR FOR 
	SELECT
		(CASE TICKET.STATUT WHEN 'A' THEN 'A' WHEN 'N' THEN 'N' ELSE 'V' END),
		TICKET_LIGNE.ID,
		TICKET_LIGNE.MONTANT_TOTAL_PRORATISE,
		(select count(*) from TICKET_LIGNE TL where TL.ID_TICKET = TICKET_LIGNE.ID_TICKET AND TL.ID_LIEN_MENU_R = TICKET_LIGNE.ID and STATUT=(CASE TICKET.STATUT WHEN 'A' THEN 'A' WHEN 'N' THEN 'N' ELSE 'V' END) and ROLE='N')
	FROM
		TICKET_LIGNE
			INNER JOIN TICKET ON TICKET_LIGNE.ID_TICKET = TICKET.ID
	WHERE
		ID_TICKET = @id and
		MENU_R = 'O' and
		MONTANT_TOTAL_PRORATISE <> (select SUM(TL.MONTANT_TOTAL_PRORATISE) from TICKET_LIGNE TL where TL.ID_TICKET = TICKET_LIGNE.ID_TICKET AND TL.ID_LIEN_MENU_R = TICKET_LIGNE.ID and STATUT=(CASE TICKET.STATUT WHEN 'A' THEN 'A' WHEN 'N' THEN 'N' ELSE 'V' END) and ROLE='N')
	
	-- Parcours des lignes remontes
	DECLARE @statut CHAR(1);
	DECLARE @id_ligne NUMERIC(14);
	DECLARE @total NUMERIC(20,6);
	DECLARE @nb_lignes NUMERIC(14);
	OPEN curLigne;
	FETCH curLigne INTO @statut, @id_ligne, @total, @nb_lignes;
	WHILE @@FETCH_STATUS = 0
	BEGIN
	
		-- On explose en autant de ligne que ncessaire
		update TICKET_LIGNE set PRIX_VENTE_TTC_PRORATISE = 0 WHERE ID_LIEN_MENU_R = @id_ligne and not (STATUT=@statut and ROLE='N')

		-- Ligne  corriger
		DECLARE curLigneInMenuR CURSOR FOR 
		SELECT
			ID
		FROM
			TICKET_LIGNE
		WHERE
			ID_TICKET = @id AND
			ID_LIEN_MENU_R = @id_ligne AND
			STATUT = @statut AND
			ROLE = 'N'

		-- Parcours des lignes  corriger
		DECLARE @id_ligne_in_menu_r NUMERIC(14);
		DECLARE @idx NUMERIC(14);
		DECLARE @cumulative NUMERIC(20,6);
		SET @idx = 1		
		SET @cumulative = 0.0
		OPEN curLigneInMenuR;
		FETCH curLigneInMenuR INTO @id_ligne_in_menu_r;
		WHILE @@FETCH_STATUS = 0
		BEGIN
		
			-- On explose en autant de ligne que ncessaire
			update TICKET_LIGNE set PRIX_VENTE_TTC_PRORATISE = CAST(ROUND(@idx * @total/@nb_lignes,2) - @cumulative as NUMERIC(20,6)), MONTANT_TOTAL_PRORATISE = CAST(ROUND(@idx * @total/@nb_lignes,2) - @cumulative as NUMERIC(20,6)) WHERE ID = @id_ligne_in_menu_r
			SET @cumulative = ROUND(@idx * @total/@nb_lignes,2)
			SET @idx = @idx + 1
			
			-- Ligne suivante
			FETCH curLigneInMenuR INTO @id_ligne_in_menu_r;
			
		END

		-- Mnage
		CLOSE curLigneInMenuR;
		DEALLOCATE curLigneInMenuR;
		
		-- Ligne suivante
		FETCH curLigne INTO @statut, @id_ligne, @total, @nb_lignes;
		
	END

	-- Mnage
	CLOSE curLigne;
	DEALLOCATE curLigne;

	-- Correction du bug tlcommande sur les menus  niveau multiple
	UPDATE TICKET_LIGNE SET PRIX_VENTE_TTC_PRORATISE = 0.0, MONTANT_TOTAL_PRORATISE = 0.0 WHERE PRIX_VENTE_TTC = 0.0 AND ID_LIEN_MENU IS NULL AND ID_LIEN_MENU_R IS NULL AND ID_TICKET = @id

	-- update TICKET_LIGNE set PRIX_VENTE_TTC_PRORATISE = 63.0/4, MONTANT_TOTAL_PRORATISE = 63.0/4 where ID in (783947,783948,783949,783950)
	-- update TICKET_LIGNE set PRIX_VENTE_TTC_PRORATISE = 17.0/2, MONTANT_TOTAL_PRORATISE = 17.0/2 where ID in (783951, 783952)
	-- update TICKET_LIGNE set PRIX_VENTE_TTC_PRORATISE = 17.0, MONTANT_TOTAL_PRORATISE = 17.0 where ID in (783953)
	
	-- On recalcule les TVA
	CREATE TABLE #T0 
	(
		ID_TICKET NUMERIC(9),
		NUMERO_DOCUMENT VARCHAR(100),
		CODE_TVA NUMERIC(9),
		TAUX_TVA NUMERIC(6,3)	 
	)
	INSERT INTO #T0 
	SELECT	DISTINCT 
			TICKET.ID AS ID_TICKET, 
			TICKET.NATURE_OP + CAST(TICKET.NUM_BALANCE AS VARCHAR) + '-' + CAST(TICKET.CODE AS VARCHAR) AS NUMERO_DOCUMENT, 
			TICKET_LIGNE.CODE_TVA AS CODE_TVA, 
			TICKET_LIGNE.TAUX_TVA AS TAUX_TVA 
	FROM	TICKET 
				INNER JOIN TICKET_LIGNE ON TICKET.ID = TICKET_LIGNE.ID_TICKET 
	WHERE	TICKET.ID = @id AND 
			TICKET_LIGNE.MENU = 'N' AND 
			TICKET_LIGNE.MENU_R = 'N' AND 
			TICKET.CODE > 0 AND
			NOT EXISTS (SELECT * FROM TICKET_TVA WHERE ID_TICKET = TICKET.ID)		
	INSERT INTO TICKET_TVA (ID_TICKET, IDENTIFIANT, NUMERO_DOCUMENT, NUMERO_LIGNE, HT, CODE_TVA, TAUX_TVA, MONTANT_TVA, TOTAL_TTC)
	SELECT	T.ID_TICKET AS ID_TICKET,
				T.NUMERO_DOCUMENT + ' | ' + CAST(T.CODE_TVA AS VARCHAR) AS IDENTIFIANT,
				T.NUMERO_DOCUMENT AS NUMERO_DOCUMENT,
				(ROW_NUMBER() OVER(PARTITION BY T.NUMERO_DOCUMENT ORDER BY T.CODE_TVA)) AS NUMERO_LIGNE,
				CAST(T.TOTAL_TTC - ROUND(T.TOTAL_TTC * T.TAUX_TVA / (100 + T.TAUX_TVA), 2) AS NUMERIC(16,2)) AS HT,
				T.CODE_TVA AS CODE_TVA,
				T.TAUX_TVA AS TAUX_TVA,
				CAST(ROUND(T.TOTAL_TTC * T.TAUX_TVA / (100 + T.TAUX_TVA), 2) AS NUMERIC(16,2)) AS MONTANT_TVA,
				T.TOTAL_TTC as TOTAL_TTC
	FROM		(
					SELECT	#T0.ID_TICKET AS ID_TICKET,
								#T0.NUMERO_DOCUMENT AS NUMERO_DOCUMENT,
								#T0.CODE_TVA AS CODE_TVA,
								#T0.TAUX_TVA AS TAUX_TVA,
								CAST(ROUND(
								( 
									SELECT	SUM(TICKET_LIGNE.MONTANT_TOTAL_PRORATISE + TICKET_LIGNE.SURCOUT_INGREDIENTS + TICKET_LIGNE.SURCOUT_MENU_R + TICKET_LIGNE.SURCOUT_ACC - TICKET_LIGNE.MONTANT_REMISE - dbo.F_GET_MONTANT_REMISE_MENU_R(TICKET_LIGNE.ID) - dbo.F_GET_MONTANT_REMISE_GLOBALE(TICKET_LIGNE.ID, TICKET.ID, TICKET.ID_REMISE, TICKET.MONTANT_REMISE, TICKET.TOTAL)) 
									FROM		TICKET_LIGNE  
													INNER JOIN TICKET ON TICKET_LIGNE.ID_TICKET = TICKET.ID  
									WHERE		TICKET_LIGNE.ID_TICKET = #T0.ID_TICKET AND  
												TICKET_LIGNE.STATUT IN ('V','A','N') AND  
												TICKET_LIGNE.MENU='N' AND  
												TICKET_LIGNE.MENU_R='N' AND  
												TICKET_LIGNE.CODE_TVA=#T0.CODE_TVA 
								), 2) AS NUMERIC(16,2)) AS TOTAL_TTC 
					FROM		#T0
				) T
	DROP TABLE #T0
	CREATE TABLE #T1 
	(
		ID_TICKET_LIGNE NUMERIC(9),
		ID_TICKET NUMERIC(9),
		CODE_TVA NUMERIC(9),
		TAUX_TVA NUMERIC(6,3),
		TTC_LIGNE NUMERIC(11,3),
		TTC_LIGNE_PREV NUMERIC(11,3),
		TTC_TICKET NUMERIC(11,3)
	)
	INSERT INTO #T1
	SELECT	TICKET_LIGNE.ID as ID_TICKET_LIGNE,
			TICKET_LIGNE.ID_TICKET as ID_TICKET,
			TICKET_LIGNE.CODE_TVA as CODE_TVA,
			TICKET_LIGNE.TAUX_TVA as TAUX_TVA,
			TICKET_LIGNE.MONTANT_TOTAL_PRORATISE + TICKET_LIGNE.SURCOUT_INGREDIENTS + TICKET_LIGNE.SURCOUT_MENU_R + TICKET_LIGNE.SURCOUT_ACC - TICKET_LIGNE.MONTANT_REMISE - dbo.F_GET_MONTANT_REMISE_MENU_R(TICKET_LIGNE.ID) - dbo.F_GET_MONTANT_REMISE_GLOBALE(TICKET_LIGNE.ID, TICKET.ID, TICKET.ID_REMISE, TICKET.MONTANT_REMISE, TICKET.TOTAL) as TTC_LIGNE,
			0,
			TICKET_TVA.TOTAL_TTC as TTC_TICKET
	FROM	TICKET_LIGNE
				INNER JOIN TICKET ON TICKET_LIGNE.ID_TICKET = TICKET.ID
					INNER JOIN TICKET_TVA ON TICKET.ID = TICKET_TVA.ID_TICKET AND TICKET_LIGNE.CODE_TVA = TICKET_TVA.CODE_TVA
	WHERE	TICKET_LIGNE.STATUT IN ('V','A','N') AND  
			TICKET_LIGNE.MENU = 'N' AND  
			TICKET_LIGNE.MENU_R = 'N' AND
			TICKET.ID = @id
	UPDATE #T1 SET TTC_LIGNE_PREV = 
	(
		SELECT	ISNULL(SUM(T2.TTC_LIGNE), 0)
		FROM	#T1 T2
		WHERE	T2.ID_TICKET = #T1.ID_TICKET AND
				T2.ID_TICKET_LIGNE < #T1.ID_TICKET_LIGNE AND
				T2.CODE_TVA = #T1.CODE_TVA
	)
	UPDATE	TICKET_LIGNE
	SET		MONTANT_HT = #T1.TTC_LIGNE - (ROUND(#T1.TAUX_TVA * (#T1.TTC_LIGNE + #T1.TTC_LIGNE_PREV) / (100 + #T1.TAUX_TVA), 2) - ROUND(#T1.TAUX_TVA * #T1.TTC_LIGNE_PREV / (100 + #T1.TAUX_TVA), 2)),
			MONTANT_TVA = ROUND(#T1.TAUX_TVA * (#T1.TTC_LIGNE + #T1.TTC_LIGNE_PREV) / (100 + #T1.TAUX_TVA), 2) - ROUND(#T1.TAUX_TVA * #T1.TTC_LIGNE_PREV / (100 + #T1.TAUX_TVA), 2)
	FROM	TICKET_LIGNE
				INNER JOIN #T1 ON TICKET_LIGNE.ID = #T1.ID_TICKET_LIGNE
	DROP TABLE #T1	

	-- Ligne suivante
	FETCH curTicket INTO @id;
	
END

-- Mnage
CLOSE curTicket;
DEALLOCATE curTicket;

-- Rsultat
DECLARE @count NUMERIC(14);
SELECT
	@count = COUNT(*)
FROM
	TICKET 
WHERE
	NATURE_OP IN ('VT', 'BL', 'HV') and 
	(
		TICKET.TOTAL - TICKET.MONTANT_REMISE  <> (select ISNULL(SUM(TT.TOTAL_TTC), 0) from ticket_tva TT where TT.ID_TICKET = TICKET.ID) 
	OR
		TICKET.TOTAL - TICKET.MONTANT_REMISE  <> (select ISNULL(SUM(TL.MONTANT_HT + MONTANT_TVA), 0) from ticket_ligne TL where TL.ID_TICKET = TICKET.ID)
	) AND
	CODE > 0 AND
	INFOS_INSTANT_T IS NOT NULL
IF @count > 0
	PRINT 'Il reste ' + CAST(@count as VARCHAR) + ' tickets en erreur. Voir avec Guillaume'
ELSE
	PRINT 'Tous les problmes sont corrigs.'
	
SET NOCOUNT OFF

