PRINT GetDate()
GO
CREATE TABLE #locks (spid int, dbid int, objid int, objectname sysname NULL,
indid int, type char(4), resource char(15), mode char(10), status char(6))
GO
delete #Locks
GO
INSERT #locks (spid, dbid, objid, indid, type, resource, mode, status)
EXEC dbo.sp_lock
GO
SELECT OBJECT_NAME(objid), * FROM #locks where type='key'
GO



SELECT  L.request_session_id AS SPID, 
        DB_NAME(L.resource_database_id) AS DatabaseName,
        O.Name AS LockedObjectName, 
        /*P.object_id AS LockedObjectId, */
        L.resource_type AS LockedResource, 
        L.request_mode AS LockType,
        ST.text AS SqlStatementText,  
        ES.login_name AS LoginName,
        ES.host_name AS HostName,
        ES.program_name as ProgramName,
        TST.is_user_transaction as IsUserTransaction,
        AT.name as TransactionName,
        CN.auth_scheme as AuthenticationMethod
FROM    sys.dm_tran_locks L
        /*LEFT JOIN sys.partitions P ON P.hobt_id = L.resource_associated_entity_id*/
        LEFT JOIN sys.objects O ON O.object_id = L.resource_associated_entity_id
        LEFT JOIN sys.dm_exec_sessions ES ON ES.session_id = L.request_session_id
        LEFT JOIN sys.dm_tran_session_transactions TST ON ES.session_id = TST.session_id
        LEFT JOIN sys.dm_tran_active_transactions AT ON TST.transaction_id = AT.transaction_id
        LEFT JOIN sys.dm_exec_connections CN ON CN.session_id = ES.session_id
        CROSS APPLY sys.dm_exec_sql_text(CN.most_recent_sql_handle) AS ST
WHERE   resource_database_id = DB_ID() and (L.resource_type = 'PAGE' or L.request_mode in ('X', 'IX'))
ORDER BY L.request_session_id



SELECT t.[text], s.last_execution_time, s.total_worker_time, s.total_elapsed_time, s.execution_count, s.creation_time, s.last_execution_time
FROM sys.dm_exec_cached_plans AS p
INNER JOIN sys.dm_exec_query_stats AS s
   ON p.plan_handle = s.plan_handle
CROSS APPLY sys.dm_exec_sql_text(p.plan_handle) AS t
where t.dbid = DB_ID('UCASH_STATS_LOCAL')
ORDER BY  s.total_elapsed_time / s.execution_count DESC;





WITH 
       BT AS
       (
             SELECT 
                    [Begin Time] AS debut,
                    [Transaction Name] AS type,
                    Operation AS operation,
                    [Transaction ID] AS numtrans
                    --AllocUnitName,
             FROM
                    sys.fn_dblog(NULL,NULL)    AS BT
             WHERE [Begin Time] IS NOT NULL
       ),
       ET AS
       (
             SELECT
                    Operation AS operation,
                    [End Time] AS fin,
                    [Transaction ID] AS numtrans
             FROM
                    sys.fn_dblog(NULL,NULL)
             WHERE 
                    [End Time] IS NOT NULL
       ),
       A AS
       (
             SELECT
                    [Transaction ID] AS numtrans,
                    AllocUnitName AS objet
             FROM
                    sys.fn_dblog(NULL,NULL)
             WHERE
                    AllocUnitName IS NOT NULL
       )
SELECT DISTINCT
       BT.type,
       BT.debut,
       ET.fin,
       BT.operation,
       ET.operation,
       A.objet
FROM
       BT 
       INNER JOIN ET ON BT.numtrans=ET.numtrans
       INNER JOIN A ON ET.numtrans=A.numtrans
WHERE
       /*ET.operation != 'LOP_ABORT_XACT'
AND*/
       BT.type IN ('UPDATE','DELETE','TRUNCATE TABLE','INSERT')
ORDER BY
       debut,fin;
GO
	Donne lhistorique des modifications dans la base de donnes,  partir du log.
Je pense que si tu remontes la base en attachant les deux fichiers mdf et ldf a doit tre conserv



SELECT dm_tran_locks.request_session_id,
       dm_tran_locks.resource_database_id,
       DB_NAME(dm_tran_locks.resource_database_id) AS dbname,
       CASE
           WHEN resource_type = 'OBJECT'
               THEN OBJECT_NAME(dm_tran_locks.resource_associated_entity_id)
           ELSE OBJECT_NAME(partitions.OBJECT_ID)
       END AS ObjectName,
       partitions.index_id,
       indexes.name AS index_name,
       dm_tran_locks.resource_type,
       dm_tran_locks.resource_description,
       dm_tran_locks.resource_associated_entity_id,
       dm_tran_locks.request_mode,
       dm_tran_locks.request_status,
       OBJECT_NAME(dm_tran_locks.request_owner_id),
       *
FROM sys.dm_tran_locks
LEFT JOIN sys.partitions ON partitions.hobt_id = dm_tran_locks.resource_associated_entity_id
LEFT JOIN sys.indexes ON indexes.OBJECT_ID = partitions.OBJECT_ID AND indexes.index_id = partitions.index_id
WHERE  resource_type = 'APPLICATION'
       AND request_mode = 'X'
       AND request_status = 'GRANT'
