﻿using System;
using System.ComponentModel;
using System.Collections.Generic;
using System.Runtime.InteropServices;
using System.Net;
using System.Text;
using System.Windows.Forms;
using System.Data;
using System.Data.Odbc;
using System.Data.SqlClient;
using System.Data.SqlServerCe;

namespace PBNet.NonVisual
{
    public class SqlCEOTF
    {
        #region Mandatory code

        /// <summary>
        /// Notify Powerbuilder.
        /// </summary>
        /// <param name="notification">the notification</param>
        public void PowerbuilderNotify(string notification)
        {
        }

        #endregion

        #region Members

        /// <summary>
        /// Connexion à la base SQL CE
        /// </summary>
        SqlCeConnection cnx;

        #endregion

        #region Ctor, Dtor, Dispose

        /// <summary>
        /// Constructor
        /// </summary>
        public SqlCEOTF()
        {
            cnx = new SqlCeConnection();
        }

        /// <summary>
        /// Destructor
        /// </summary> 
        ~SqlCEOTF()
        {
            if (cnx.State == ConnectionState.Open)
                cnx.Close();
        }

        #endregion

        #region Méthods

        /// <summary>
        /// Connexion à la source de données
        /// </summary>
        /// <param name="datasource">Fichier de base de données</param>
        /// <param name="pwd">Mot de passe</param>
        /// <returns>0 si OK, -1 sinon</returns>
        public int Connect(string datasource, string pwd)
        {
            // Paramètres de connexion
            cnx.ConnectionString = "Data Source=" + datasource + ";Password=" + pwd + ";Persist Security Info=False;";
            
            // Ouverture de la connexion
            try
            {
                cnx.Open();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
                return 0;
            }

            // Traitement OK
            return 0;
        }

        /// <summary>
        /// Déconnexion de la source de données
        /// </summary> 
        public void Disconnect()
        {
            // Fermeture de la connexion
            cnx.Close();
        }

        /// <summary>
        /// Exécution d'une requête de type SELECT
        /// </summary>
        /// <param name="query">La requête</param>
        /// <returns>Les données remontées (au format XML)</returns>
        public string ExecuteQuery(string query)
        {
            // Chaîne retour
            string result = "";

            // Commande pour l'exécution
            SqlCeCommand cmd = new SqlCeCommand(query, cnx);
            cmd.CommandType = CommandType.Text;

            // Exécution de la requête
            try
            {
                // Exécution
                SqlCeDataReader res = cmd.ExecuteReader( );

                // Les données
                int cnt = 0;
                while (res.Read())
                {
                    cnt++;
                    for (int i = 0; i < res.FieldCount; i++)
                        result += "<" + res.GetName(i) + "." + cnt + ">" + res.GetValue(i) + "</" + res.GetName(i) + "." + cnt + ">";
                }
                result = "<RETURN>0</RETURN><COUNT>" + cnt + "</COUNT>" + result;
            }
            catch (Exception e)
            {
                result += "<RETURN>-1</RETURN><MSG>" + e.Message + "</MSG>";
            }
            return result;
        }

        /// <summary>
        /// Exécution d'une requête de type INSERT, UPDATE ou DELETE
        /// </summary>
        /// <param name="query">La requête</param>
        /// <returns>?</returns>
        public string ExecuteNonQuery(string query)
        {
            // Chaîne retour
            string result = "";

            // Commande pour l'exécution
            SqlCeCommand cmd = new SqlCeCommand(query, cnx);
            cmd.CommandType = CommandType.Text;

            // Exécution de la requête
            try
            {
                // Exécution
                cmd.ExecuteNonQuery();
                result += "<RETURN>0</RETURN>";
            }
            catch (Exception e)
            {
                result += "<RETURN>-1</RETURN><MSG>" + e.Message + "</MSG>";
            }
            return result;
        }

        #endregion

    }
}
