﻿using System;
using System.Runtime.InteropServices;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

namespace PBNet.Visual
{
    public class WebBrowserOTF : System.Windows.Forms.UserControl 
    {
        #region Mandatory code

        /// <summary>
        /// Components
        /// </summary>
        private System.ComponentModel.IContainer components = null;

        /// <summary>
        /// Notify Powerbuilder
        /// </summary>
        /// <param name="notification">the new notification</param>
        public void PowerbuilderNotify(string notification)
        {
        }

        /// <summary>
        /// Define Tab Order
        /// </summary>
        /// <param name="ctrl"></param>
        public void SetTabOrder(Control[] ctrl)
        {
        }

        #endregion

        #region Members

        // The Web Browser
        private WebBrowser webBrowser1;

        #endregion

        #region Ctor, Dtor, Dispose

        /// <summary>
        /// Constructor
        /// </summary>
        public WebBrowserOTF()
        {
            InitializeComponent();
            this.SetTabOrder(new Control[] { this.webBrowser1 });
        }

        /// <summary>
        /// Dispose
        /// </summary>
        /// <param name="disposing"></param>
        protected override void Dispose(bool disposing)
        {
            if (disposing && (components != null))
                components.Dispose();
            base.Dispose(disposing);
        }

        /// <summary>
        /// Initialize component
        /// </summary>
        private void InitializeComponent()
        {
            this.webBrowser1 = new System.Windows.Forms.WebBrowser();
            this.SuspendLayout();
            // 
            // webBrowser1
            // 
            this.webBrowser1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.webBrowser1.Location = new System.Drawing.Point(0, 0);
            this.webBrowser1.MinimumSize = new System.Drawing.Size(20, 20);
            this.webBrowser1.Name = "webBrowser1";
            this.webBrowser1.Size = new System.Drawing.Size(150, 150);
            this.webBrowser1.TabIndex = 0;
            this.webBrowser1.DocumentCompleted += new System.Windows.Forms.WebBrowserDocumentCompletedEventHandler(this.WebBrowserOTF_DocumentCompleted);
			this.webBrowser1.ObjectForScripting = this;
            // 
            // WebBrowserOTF
            // 
            this.Controls.Add(this.webBrowser1);
            this.Name = "WebBrowserOTF";
            this.ResumeLayout(false);

        }

        #endregion

        #region Méthods

        /// <summary>
        /// Load an URL
        /// </summary>
        /// <param name="url"></param>
        public void Navigate(string url)
        {
            this.webBrowser1.Navigate(url);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="script"></param>
        /// <returns></returns>
        public string InvokeScript(string script) {return (this.webBrowser1.Document.InvokeScript(script).ToString());}
        public string InvokeScript(string script, string param01) {return (this.webBrowser1.Document.InvokeScript(script, new object[] { (object)param01 })).ToString();}
        public string InvokeScript(string script, string param01, string param02) {return (this.webBrowser1.Document.InvokeScript(script, new object[] { (object)param01, (object)param02 })).ToString();}
        public string InvokeScript(string script, string param01, string param02, string param03) { return (this.webBrowser1.Document.InvokeScript(script, new object[] { (object)param01, (object)param02, (object)param03 })).ToString(); }
        public string InvokeScript(string script, string param01, string param02, string param03, string param04) { return (this.webBrowser1.Document.InvokeScript(script, new object[] { (object)param01, (object)param02, (object)param03, (object)param04 })).ToString(); }

        public void SendNotification(string notification)
        {
            this.PowerbuilderNotify(notification);
        }

        public void AnswerPDV(string answer)
        {
            this.webBrowser1.Document.InvokeScript("PDVMessage", new object[] { (object)answer});
        }

        public void AskPDV(string msg)
        {
            this.PowerbuilderNotify(String.Format("<Event>AskPDV</Event><Message>{0}</Message>", msg));
        }

        #endregion

        #region Event Handlers

        /// <summary>
        /// Notify when a webpage is completed
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void WebBrowserOTF_DocumentCompleted(object sender, WebBrowserDocumentCompletedEventArgs e)
        {
            this.SendNotification(String.Format("<Event>DocumentCompleted</Event><Url>{0}</Url>", e.Url.ToString()));
        }
		
        #endregion
    }
}